---
name: Onboarding
about: A checklist of onboarding tasks for new team members
title: ''
labels: ''
assignees: ''

---

**Onboarding checklist for new team members**

This should be created at least a couple of days before a new member comes on board.


**IDIR**
- [ ] Complete the form located at "R:\ARCS\HR 1300-1999\01 General\Onboarding Offboarding", which is stored on an internal drive and must be accessed by staff.
- [ ] Submit to IT Operations Support. This form should be emailed to the Registries Executive Assistant. Currently this role is held by Michael Leung.

-----------------

**Legacy Applications**
- [ ] Access to legacy applications is requested through the IDIR form listed above. This form should be emailed to the Registries Executive Assistant. Currently this role is held by Michael Leung.

-----------------

**Business Registry**
- [ ] Requests for access to any Registries applications should be sent to IT Operations Support.

-----------------

**GitHub & ZenHub**
- [ ] 1. First, the new user is to go to github.com to register their account (using all lower-case for their name if it's a new account)
- [ ] 2. Next, the new user is to verify that 2 factor authentication is enabled 
- [ ] 3. Once the account creation and 2fa are completed, add an SRE and Priority label to this ticket
- [ ] 4. Comment on this ticket to indicate which project /team/product does this member need and move this ticket to the Priority pipeline on the SRE board
- [ ] 5. Once added, the employee will need to install the Zenhub plugin in the Chrome browser - https://chrome.google.com/webstore/detail/zenhub-for-github/ogcgkffhplmphkaahpmffcafajaocjbd

-----------------

**RocketChat**
- [ ] New user to download the RochatChat App and follow the instructions to Register a new account. (IT Operations Support will assign requests for access to the Business Registry to Relationships BA's (Melissa and Amit))

-----------------

**Meeting Invitations**
- [ ] The new team member has been invited to all of the required scrum team meetings and ceremonies by the team Scrum Master
- [ ] The new team member has been invited to all of the cross-team events by the Release Train Engineer (sprint demo, dev tech demo)

-----------------

**Business Context**
- [ ] The new team member has been informed of the Team Vacation Calendar and have added their name to it
- [ ] Set up meeting for business context knowledge transfer
- [ ] The new team member's contact information has been added to the "Team BCR Overview" document https://citz.sp.gov.bc.ca/sites/SBC/REG/Projects/MVSM/_layouts/15/WopiFrame.aspx?sourcedoc={5F6ECE64-702C-49BF-A02F-8B46ABF5B67E}&file=Team%20BCR%20Overview.xlsx&action=default
 
-----------------

**OpenShift**
- [ ] Required for developers, Patrick Wei or Richard Armitage would advise the user to send a web access request through https://github.com/BCDevOps/devops-requests/issues/

-----------------

**OpenShift NameSpace Access**
- [ ] For developers and completed by Admin: Patrick Wei, Kial Jinnah, or Richard Armitage.

-----------------

**Google Drive Access for Knowledge Sharing Videos**
- [ ] Read access to https://drive.google.com/drive/folders/1tl3h0XnZZdlOR440CJjM-KHvvHgXCHoV (currently Linda, Maribeth and Trish can share this)

-----------------

**Ops Team Onboarding**

- [ ] Developers or BAs are added to Ops repo
- [ ] Develooers or BAs are given Edit permissions for the Knowledge Base (Ops Google Drive folder https://drive.google.com/drive/folders/1KK_IFAdAJz9-d7rPwUYYoFXBOfBzqlZx?usp=sharing)
- [ ] BA have access to shared BA inbox
- [ ] Set up overview meeting with another Dev/BA to cover process and common requests (including review of the Knowledge Base and how to contriburte)
- [ ] Access to prod dashboard and databases (read-only for BAs to review client status for requests - SOFI, Namex and Business Registries)
- [ ] Set up meeting for training on an overview of each application and each DB. 
- [ ] If available, API testing training using Postman
