Test-Automation & DevOps 
=============
Overview and Action Items we derive & execute 
-------------

* I. This is an overview and includes a description with ideas, for next few iterations and upcoming few monhts.
* II. Input from team members, observations, and the recommendations from John Lane (link see in then end)
* III. Epics will be created for bigger topics for a few iterations. 
* IV. Action items will be defined as issues in a certain Epic (User Story or task?) (per one issue). 
* V. A story will be pulled into a Sprint to work on it, track the progress and see the progress. 

----

**Problem:**              
Manual testing: Benefits of a DevOps CI/CD process have been missed - slowing down both teams, and Bottleneck in QA. 

**What we want:**     
Fast and frequent releases (every Sprint) of a quality product, test-automation where possible for faster testing.

----


Epics and Timeline
=============
* Dec 2019 - Feb 18   # 2144   https://app.zenhub.com/workspaces/entity-5bf2f2164b5806bc2bf60531/issues/bcgov/entity/2144
* Feb 18 - June xx       x add link
* ... (will be created by Thor in collaboration w. Roland & John Lane) 

----

**Related and relevant topics for the next few months that to help create Epics and Action Items**
- Monitoring
- CD: How do we want to deploy our environments? - tools etc. 
- Environments
- Test Strategy 
- Test Process 
> This topics has to be broken down into Epics and then smaller work items/ action items. 
----



Background: Input, Workshops & Discussions
-------------
This overview is based on our discussions and workshops as well as John´s recommendations. 

**John´s Recommendations:**
+ (1). Product Owners should lead the teams through DevOps Self-Assessments at regular intervals. 
    Gaps identified in this review should be discussed and prioritized as part of Backlog Grooming and Sprint Planning. 
 
+ (2). DoD: Each story must include automated unit and integration tests that run in a pipeline prior to being considered complete. 

+ (3). The team (beginning with the Product Owner and Scrum Master) should begin to track certain key metrics related to system/ process health. Here are some good ones to start with:
    + 3.1 Application usage and traffic (who is using our app and are they successful?)
    + 3.2 # of failed deployments (releases that cause bugs/outages)
    + 3.3	Lead time to production (elapsed time from moving to in progress to being in production)
    + 3.4	Mean time to recovery (How long a bug lives in production)

**Document of John´s Recommendations:**
https://app.zenhub.com/files/157936592/958b20d9-f077-4ca0-aa9c-b42a94cccce1/download


----
**Next Steps & Actions we identified a few weeks ago:** 
- [x] Sprint 20: Workshop w. Roland (Thor) - story created:   #2148
- [x] Sprint 20: SRE DevOps Assessment (Thor) --- Recommendations and tickets to our backlog. - see tasks created in Epic
- [ ] Sprint 21: Update DoD to include functional, integration test (Thor w. Scrum Master) 
- [ ] Sprint 22: Integration testing should be part of a User Story/ QA is part of a Scrum Team (Scrum Master) 
* We agreed that Thor will create user stories and link them to this Epic.
* Thor is working together with Roland Stens and John Lane.

** Rough Notes
## Whats the scope of work
- Automated build of Environments and import of relevant configurations(Env in Question: Dev/Test/Prod)
- Automated Integration Tests
    - Is Github actions part of this?
    - When test gets kicked off, all the other integrated components are not impacted
- Regression testing
    - How much of this needs tobe automated
    - Is this covered in Night watch?
- Metrics in terms of Monitoring of App
    - What have we done alredy?
    - How much we want to do more?
    
## Steps of the action plan:
- Gather information about gaps and come up with scope
- To have a story workshop and define the requirements in Epics and stories
    - Perform estimation to understand how big the work is.
    - Prirotize and define MVP for this work
    
